package ru.yurannnzzz.compat.figuraheadseverywhere.mixin.chatheads;

import dzwdz.chat_heads.ChatHeads;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.multiplayer.PlayerInfo;
import org.figuramc.figura.avatar.Avatar;
import org.figuramc.figura.avatar.AvatarManager;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(value = ChatHeads.class, remap = false)
public class ChatHeadsMixin {
    @Inject(
            at = @At("HEAD"),
            method = "renderChatHead(Lnet/minecraft/client/gui/GuiGraphics;IILnet/minecraft/client/multiplayer/PlayerInfo;F)V",
            cancellable = true
    )
    private static void renderAvatar(GuiGraphics guiGraphics, int x, int y, PlayerInfo owner, float opacity, CallbackInfo ci) {
        if (owner != null) {
            Avatar avatar = AvatarManager.getAvatarForPlayer(owner.getProfile().getId());
            if (avatar != null && avatar.renderPortrait(guiGraphics, x, y, 8, 16.0F, false)) {
                ci.cancel();
            }
        }
    }
}
